#include <SoftwareSerial.h>
#include "MeAuriga.h"
#include <math.h>

//angles in deg
float phi1_deg;
float phi2_deg;
//arm lengths
float length1 = 92.9;
float length2 = 77.1;
float R_min = 115.44;
float R_max = length1 + length2;
//coordinates
float xCoordinate;
float yCoordinate;
String coordinates;
int delimiter;

//initialize servos
MeSmartServo MyRobot(PORT5);

//required booleans
boolean headerSent = false;


void setup() {
  //start serial communication
  Serial.begin(115200);
  while(!Serial) {}
  delay(50);
  Serial.println(F("\n\n\ntool is starting..."));
  delay(50);
  MyRobot.begin(115200);
  delay(5);
  MyRobot.assignDevIdRequest();
  delay(50);
  MyRobot.setZero(1);
  delay(50);
  MyRobot.setZero(2);
  delay(50);
  MyRobot.moveTo(1, 45, 1);
  delay(2000);
  MyRobot.moveTo(2, 45, 1);
  delay(2000);
  MyRobot.moveTo(1, 0, 1);
  delay(2000);
  MyRobot.moveTo(2, 0, 1);
  delay(2000);
  Serial.println(F("tool is ready to use!"));
}

void loop() {
  if (!headerSent) {
    Serial.println(F("\n\nyour coordinates separated by a comma:"));
    headerSent = true;
  }
  coordinates = Serial.readString();
  if (coordinates != "") {
    Serial.println(coordinates);
    delimiter = coordinates.indexOf(",");
    if (delimiter == -1) {
      Serial.println(F("\n\ninavlid format!"));
    }
    else {
      String xString = coordinates.substring(0, delimiter);
      xCoordinate = xString.toFloat();
      String yString = coordinates.substring(delimiter+1, coordinates.length()-1);
      yCoordinate = yString.toFloat();
      if (xString != "0" and xCoordinate == 0) {
        xCoordinate = -1;
      }
      if (yString != "0" and yCoordinate == 0) {
        yCoordinate = -1;
      } 
      if (xCoordinate != -1 and yCoordinate != -1) {
        delay(2000);
        set_position(xCoordinate, yCoordinate);
      }
      else {
        Serial.println(F("\n\ncould not convert to number!"));
      }
    }
    headerSent = false;
  }
}

void set_position(float x, float y) {
  float R = sqrt(square(x) + square(y));
  if (R < R_min or R > R_max) {
    Serial.println(F("coordinates out of range"));
    return;
  }
  float cos_phi2 = (square(x) + square(y) - square(length1) - square(length2)) / (2*length1*length2);
  delay(50);
  float phi2 = atan2(sqrt(1 - square(cos_phi2)), cos_phi2);
  delay(50);
  float theta1 = atan2(y, x) - atan(length2*sin(phi2)/(length1+length2*cos(phi2)));
  delay(50);
  phi1_deg = -theta1*180/M_PI;
  delay(50);
  if (abs(phi1_deg) > 95) {
    Serial.println(F("coordinates out of range!"));
    return;
  }
  delay(50);
  phi2_deg = phi2*180/M_PI;
  if (abs(phi2_deg) > 95) {
    Serial.println(F("coordinates out of range!"));
    return;
  }
  delay(500);
  Serial.println(F("coordinates are being set..."));
  delay(500);
  MyRobot.moveTo(1, phi1_deg, 1);
  delay(2000);
  MyRobot.moveTo(2, phi2_deg, 1);
  delay(2000);
  Serial.println(F("new position has been set!"));
}
